package entity

import (
	"leafdev.top/Leaf/api-platform/internal/schema"
	"time"
)

type Order struct {
	Model
	UserId      schema.UserId    `json:"user_id"`
	PromoCodeId *schema.EntityId `json:"promo_code_id"`
	PromoCode   *PromoCode       `json:"promo_code"`
	Price       float64          `json:"price"`
	OrderDate   time.Time        `json:"order_date"`
}

func (u *Order) TableName() string {
	return "orders"
}

type OrderItem struct {
	Model
	OrderId   schema.EntityId `json:"order_id"`
	PackageId schema.EntityId `json:"package_id"`
	Order     *Order
	Package   *Packages
}

func (u *OrderItem) TableName() string {
	return "order_items"
}
